/*   
    
    Chess-Ec  Vers      Copyright (C)   2001-2008 Marc Dechico

    ec_init.c : all initialisation needed by the application 
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  

*/

/*****************************************************************************/
/*  Initialisation tableau et variable 					     */
/*****************************************************************************/

#include "ec_init.h"


void ini_pgm (void)
{
  extern int new_evaluation(struct st_evaluation **ppst_eva);
  ini_msg();
  ini_sim();	
  new_evaluation(&pst_evaluation); 
  ini_dsk();

}

void ini_sim(void)
{
  //int x;
  /* initialise tableaux pieces */
  ini_pie();

  /* initialise tableau historique */
  ini_hst(NOIR);

  /* initialise tableau échiquier */
  ini_ech();

  /* intalle les pieces */
  ins_pie_01();

  /* sauvegarde position des pieces pour controle égalité */
  sav_pos(0);

  /* profondeur actuelle */
  i_pro_act=0;		 
		
  /*disponibilite de la note pour affichage */
  defv_aff_not_pos = N;	

  if (i_first_time_init==0)
    {
      /* Version utilisé pour évaluation du meilleur mvt */
      extern int ver_ini(void);
      extern void cho_ver2 (int i_ver);
      extern int i_cot_aff;
      extern int i_end_gam;
      extern int res_gam(void);
      extern int restore_configuration(void);
      extern volatile defv_bool defv_bool_sigterm; 
      ver_ini();
      cho_ver2(MEDIUM1);
      /* cote d'affichage */
      i_cot_aff  =  BLANC;
      i_side  =  BLANC;
      i_first_time_init=1;
      i_end_gam=0;
      res_gam();
      restore_configuration();
      defv_bool_sigterm = FALSE;
    }


  /* initialisation fonction rand() */
  /* to reproduce the behavior should save the data */
  seed_ran_cho ();
  
}

void ini_pie(void)
{
  /* initialisation tableaux pièces */ 
  int x;
		
  /* chargement du tableau de camp */
  tpts_pie[BLANC]= ts_pie_0;
  tpts_pie[NOIR]= ts_pie_1;
		
   /* initialisation tableau piece  */
  ts_pie_0[0].i_pie_sui=17;
  ts_pie_0[17].i_pie_pre=0;
  ts_pie_1[0].i_pie_sui=17;
  ts_pie_1[17].i_pie_pre=0;
	
  for (x=0;x<18;x++)
    {
      ts_pie_0[x].i_Id=x;
      ts_pie_1[x].i_Id=x;
    }		
}
/* initialisation du camp  historique */
int ini_hst (int i_cam_hst_0)
{
        int pro;
	ts_hst_pro[0].i_pro=0;
	ts_hst_pro[0].defv_ech = N;
	ts_hst_pro[0].defv_mat = N;
	ts_hst_pro[0].defv_pat = Y;
	ts_hst_pro[0].i_not = 0;
	ts_hst_pro[0].i_typ_mvt = 0;

	switch (i_cam_hst_0)
	{
		case 0:
			ts_hst_pro[0].i_cam 		= BLANC;
			ts_hst_pro[0].i_cam_adv 	= NOIR;
			break;
		case 1:
			ts_hst_pro[0].i_cam 		= NOIR;
			ts_hst_pro[0].i_cam_adv 	= BLANC;
			break;
		default:
			return 1;
	}

	for (pro=1;pro<PRO_HST;pro++)
	{
		ts_hst_pro[pro].i_pro		= pro;
		ts_hst_pro[pro].i_cam 		= ts_hst_pro[pro-1].i_cam_adv;
		ts_hst_pro[pro].i_cam_adv 	= ts_hst_pro[pro-1].i_cam;
		ts_hst_pro[pro].pts_pie_pc      = tpts_pie[ts_hst_pro[pro].i_cam];
		ts_hst_pro[pro].pts_pie_ca      = tpts_pie[ts_hst_pro[pro].i_cam_adv];
	}

	/* fct : voir  permettre de modifier les flag de roc si configuration spéciale au départ */

	/* init roc */
	for (pro=0;pro<PRO_HST;pro++)
	  {
	    ts_hst_pro[pro].ti_roc_cam_typ[BLANC][PET_ROC]=0;
	    ts_hst_pro[pro].ti_roc_cam_typ[BLANC][GRA_ROC]=0;
	    ts_hst_pro[pro].ti_roc_cam_typ[NOIR ][PET_ROC]=0;
	    ts_hst_pro[pro].ti_roc_cam_typ[NOIR ][GRA_ROC]=0;
	  }

	return 0;

}

void ini_ech (void)
{	
  /* initialisation tableau echiquier */
  /* hors limite cam = HOR_ECH (-2), ID = VIDE(-1)    */
  int x,y;
  for (x=0;x<=9;x++)
    {
      for (y=0;y<=9;y++)
	{
	  nn=(y*10)+x;
	  ts_ech[nn].i_cam = HOR_ECH; 
	  ts_ech[nn].i_Id = VIDE;
	}
    }
  /* dans limite cam = VIDE (-1), ID = VIDE (-1)    */
  for (x=1;x<=8;x++)
    {
      for (y=1;y<=8;y++)
	{
	  nn=(y*10)+x;
	  ts_ech[nn].i_cam = VIDE;
	}
    }


}
/*
void ins_pie_01(void)
{ 
	int err;


	

	 err =ajo_pie(BLANC,'r',E1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',B6);   if (err != 0)  printf("Erreur : %i\n",err);
	 //	 err =ajo_pie(BLANC,'f',C1);   if (err != 0)  printf("Erreur : %i\n",err);

	 err =ajo_pie(NOIR,'r',E8);   if (err != 0)  printf("Erreur : %i\n",err);	
	 //	 err =ajo_pie(NOIR,'c',H6);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(NOIR,'f',C8);   if (err != 0)  printf("Erreur : %i\n",err);
}

void ins_pie_01(void)
{ 
	int err;


	

	 err =ajo_pie(BLANC,'t',D1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'c',B3);   if (err != 0)  printf("Erreur : %i\n",err);
	 //	 err =ajo_pie(BLANC,'f',C1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'d',B5);   if (err != 0)  printf("Erreur : %i\n",err);	 
	 err =ajo_pie(BLANC,'r',C1);   if (err != 0)  printf("Erreur : %i\n",err); 
         //err =ajo_pie(BLANC,'f',F1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'c',F3);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'t',C2);   if (err != 0)  printf("Erreur : %i\n",err);
	
	 	
	 err =ajo_pie(BLANC,'p',B2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',A4);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',F4);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',H4);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',D5);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(BLANC,'p',F2);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(BLANC,'p',G2);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(BLANC,'p',H2);   if (err != 0)  printf("Erreur : %i\n",err);
	 
	 
	 err =ajo_pie(NOIR,'t',A8);   if (err != 0)  printf("Erreur : %i\n",err);	
	 err =ajo_pie(NOIR,'c',H6);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'f',C8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'d',D6);   if (err != 0)  printf("Erreur : %i\n",err);
 	 err =ajo_pie(NOIR,'r',B7);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(NOIR,'f',F8);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(NOIR,'c',G8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'t',H8);   if (err != 0)  printf("Erreur : %i\n",err);
	 
	 err =ajo_pie(NOIR,'p',A5);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',F5);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',H5);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',B6);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',E6);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',G6);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(NOIR,'p',G7);   if (err != 0)  printf("Erreur : %i\n",err);
	 //err =ajo_pie(NOIR,'p',H7);   if (err != 0)  printf("Erreur : %i\n",err);
	 
}
*/
 
void ins_pie_01(void)
{ 
	int err;


	

	 err =ajo_pie(BLANC,'t',A1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'c',B1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'f',C1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'d',D1);   if (err != 0)  printf("Erreur : %i\n",err);	 
	 err =ajo_pie(BLANC,'r',E1);   if (err != 0)  printf("Erreur : %i\n",err); 
         err =ajo_pie(BLANC,'f',F1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'c',G1);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'t',H1);   if (err != 0)  printf("Erreur : %i\n",err);
	
	 	
	 err =ajo_pie(BLANC,'p',A2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',B2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',C2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',D2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',E2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',F2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',G2);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(BLANC,'p',H2);   if (err != 0)  printf("Erreur : %i\n",err);
	 
	 
	 err =ajo_pie(NOIR,'t',A8);   if (err != 0)  printf("Erreur : %i\n",err);	
	 err =ajo_pie(NOIR,'c',B8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'f',C8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'d',D8);   if (err != 0)  printf("Erreur : %i\n",err);
 	 err =ajo_pie(NOIR,'r',E8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'f',F8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'c',G8);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'t',H8);   if (err != 0)  printf("Erreur : %i\n",err);
	 
	 err =ajo_pie(NOIR,'p',A7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',B7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',C7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',D7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',E7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',F7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',G7);   if (err != 0)  printf("Erreur : %i\n",err);
	 err =ajo_pie(NOIR,'p',H7);   if (err != 0)  printf("Erreur : %i\n",err);
	 
}





/* Messages utilisateurs */
void ini_msg (void)
{
tptc_msg[MSG_CHA_MES_LON_MSG]	=		N_("Programe error: Message too long ");
tptc_msg[MSG_CHO_COT_INV]	=		N_("Valide choice: s h m  or s m h  ");
tptc_msg[MSG_CHO_INC_INV]	=		N_("Increment must be %s to %s");
tptc_msg[MSG_CHO_NIV_INC_INV]	=		N_("Level + Increment must be below: %s");
tptc_msg[MSG_CHO_NIV_INV]	=		N_("Level must be %s to %s");
tptc_msg[MSG_EXI_MVT_INI_NON]	=		N_("Movement number doesn't exixt");
tptc_msg[MSG_JOU_CTFR_ROI_ECH]	=		N_("King can't become  chess after his own piece move ");
tptc_msg[MSG_JOU_GRD_ROC_ROC_IMP]	=	N_("Castling not permitted");
tptc_msg[MSG_JOU_INT_COL_ARR_INV]	=	N_("Bad destination's column ");
tptc_msg[MSG_JOU_INT_COL_DEP_INV]	=	N_("Bad departure's column ");
tptc_msg[MSG_JOU_INT_LIG_ARR_INV]	=	N_("Bad destination's line ");
tptc_msg[MSG_JOU_INT_LIG_DEP_INV]	=	N_("Bad departure's line ");
tptc_msg[MSG_JOU_PAS_DE_PIE]	=		N_("No piece in this field");
tptc_msg[MSG_JOU_PAS_VOT_TOU]	=		N_("The piece moved is %s and turn to %s");
tptc_msg[MSG_JOU_PET_ROC_ROC_IMP]	=	N_("King side castling  not allowed in this case ");
tptc_msg[MSG_JOU_PIB_2CA_IMP]	=		N_("Pawn can jump two fields only from line 2");
tptc_msg[MSG_JOU_PIB_ARR_OCC]	=		N_("Destination field not vacant");
tptc_msg[MSG_JOU_PIB_INT_OCC]	=		N_("The two fields above the pawn must be vacant");
tptc_msg[MSG_JOU_PIB_MVT_IMP]	=		N_("Movement not allowed for the pawn");
tptc_msg[MSG_JOU_PIB_PAS_PIE_PRI]	=	N_("Movement allowed only if a piece can be taken");
tptc_msg[MSG_JOU_PIN_2CA_IMP]	=		N_("Pawn can jump two fields only from line 7");
tptc_msg[MSG_JOU_PIN_MVT_IMP]	=		N_("Movement not allowed for the pawn");
tptc_msg[MSG_JOU_PIO_PIE_PRO_INV]	=	N_("Programe Error: Bad piece code returned for pawn's promotion");
tptc_msg[MSG_JOU_PIO_ROI_ECH]	=		N_("King can't be put chess after his own piece move");
tptc_msg[MSG_JOU_POS_REP_P3F]	=		N_("Third time with the same board position : drawn game");
tptc_msg[MSG_JOU_PRI_PRO_CAM]	=		N_("Can't take a piece of it's own side");
tptc_msg[MSG_JOU_ROI_GRD_ROC_IMP]	=	N_("Queen side castling  not allowed in this case");
tptc_msg[MSG_JOU_ROI_PET_ROC_IMP]	=	N_("King side castling  not allowed in this case");
tptc_msg[MSG_JOU_ROI_ROI_ECH]	=		N_("King can't move to a field where he becomes chess");
tptc_msg[MSG_MVT_CAV_MVT_IMP]	=		N_("Movement not allowed for the knight");
tptc_msg[MSG_MVT_FOU_MVT_IMP]	=		N_("Movement not allowed for the bishop");
tptc_msg[MSG_MVT_FOU_SAU_PIE]	=		N_("Bishop can't jump over a piece");
tptc_msg[MSG_MVT_REI_MVT_IMP]	=		N_("Movement not allowed for the queen");
tptc_msg[MSG_MVT_REI_SAU_PIE]	=		N_("Queen can't jump over a piece");
tptc_msg[MSG_MVT_ROI_MVT_IMP]	=		N_("Movement not allowed for the king");
tptc_msg[MSG_MVT_TOU_MVT_IMP]	=		N_("Movement not allowed for the rook");
tptc_msg[MSG_MVT_TOU_SAU_PIE]	=		N_("Rook  can't jump over a piece");
tptc_msg[MSG_PAS_COU_PRE]	=		N_("No previous movement");
tptc_msg[MSG_RST_DSK_ERR_DON]	=		N_("Bad datas in file ");
tptc_msg[MSG_RST_DSK_ERR_FIC]	=		N_("Error reading disk file ");
tptc_msg[MSG_SAV_DSK_ERR_FIC]	=		N_("Error writing disk file");
tptc_msg[MSG_SIMU_HST_SIZ]	=		N_("Table ts_hst_pro to little");
tptc_msg[MSG_SIMU_MAT_BLANC]	=		N_("Checkmate.. white won!");
tptc_msg[MSG_SIMU_MAT_NOIR]	=		N_("Checkmate.. black won!");
tptc_msg[MSG_SIMU_PAT_BLANC]	=		N_("Stalemate..drawn game!");
tptc_msg[MSG_SIMU_PAT_NOIR]	=		N_("Stalemate..drawn game! ");
tptc_msg[MSG_TYP_LIB_CAV]	=		N_("Knight->type n");
tptc_msg[MSG_TYP_LIB_REI]	=		N_("Queen->type q");
tptc_msg[MSG_VER_AFF_NOT_IMP]	=		N_("Mark not available: type r to reckon again");
tptc_msg[MSG_VER_CHO_PRO_PIO]	=		N_("The pawn can be promoted to : %s or  %s");
tptc_msg[MSG_LIB_BLANC]	        =		N_("white");
tptc_msg[MSG_LIB_NOIR]	        =		N_("black");

}

/*  Ajouter piece  */
int ajo_pie (int i_cam,char c_cod_pie,int i_coo_n)
{

	/* bug */
	/* Ne pas permettre l'ajout de  2 roi dans le meme camp */

	int i_Id_pre,i_Id_nou;			/* N°  de piece precedement ajouté ,et  */
						/* ajouter       	  		 */
	/* struct st_pie  	*pts_pie_ajo; */	/* ptr tableau struct pièce */

	if (i_cam != BLANC && i_cam != NOIR) return 1;         /* N° camp invalide */

	i_Id_pre =(tpts_pie[i_cam]+17)->i_pie_pre;
	i_Id_nou = i_Id_pre+1;
	
	if (i_Id_pre == 16)
		return 2;                                   /* Nombre de pièce max atteint */
	else
		pts_pie = tpts_pie[i_cam]+i_Id_nou;

	if (i_coo_n <0 
	    ||
	    i_coo_n>99
	    || 
	    ts_ech[i_coo_n].i_Id == HOR_ECH)
	return 3;                                   /* Coordonée pièce invalide */
	

	if (ts_ech[i_coo_n].i_Id != VIDE)         /* case déjà occupée */
	  return 5;                                        /* opti ajouter message */

	/* Controle  Ok la pièce peut être crée */
	
	/* Mise à jour coordonnées */
	pts_pie->i_pos_n 	= i_coo_n ;
	
	/* Mise à jour tableau echiquier */
	ts_ech[i_coo_n].i_cam = i_cam;
	ts_ech[i_coo_n].i_Id = i_Id_nou;

	/* Insertion piece dans tableau pièces */
	pts_pie->i_pie_sui 	= 17 ;
	pts_pie->i_pie_pre 	= i_Id_pre;
	(tpts_pie[i_cam]+i_Id_pre)->i_pie_sui = i_Id_nou ;
	(tpts_pie[i_cam]+17)->i_pie_pre = i_Id_nou;


	switch (c_cod_pie)
	{

		case 'r':
					/* bug : controler si roi deja existant ds ce camp */
					if (i_cam == BLANC)
					{
						set_pie_roi_blanc();
						Id_roi[BLANC] = i_Id_nou;
					}
					else
					{
						set_pie_roi_noir();
						Id_roi[NOIR] = i_Id_nou;
					}
					break;

		case 'd':
					if (i_cam == BLANC)
						set_pie_rei_blanc();
					else
						set_pie_rei_noir();
					break;

		case 'f':
					if (i_cam == BLANC)
						set_pie_fou_blanc();
					else
						set_pie_fou_noir();
					break;
		case 't':
					if (i_cam == BLANC)
					{
						set_pie_tou_blanc();
						if(i_coo_n == A1)
						ti_tou_cam_typ [BLANC][GRA_ROC]=i_Id_nou;
						
						if(i_coo_n == H1)
						ti_tou_cam_typ [BLANC][PET_ROC]=i_Id_nou;
					}
					else
					{
						set_pie_tou_noir();
						if(i_coo_n == A8)
						ti_tou_cam_typ [NOIR][GRA_ROC]=i_Id_nou;
						if(i_coo_n == H8)
						ti_tou_cam_typ [NOIR][PET_ROC]=i_Id_nou;
					}
					break;
		case 'c':
					if (i_cam == BLANC)
						set_pie_cav_blanc();
					else
						set_pie_cav_noir();
					break;
		case 'p':
					if (i_cam == BLANC)
						set_pie_pio_blanc();
					else
						set_pie_pio_noir();
					break;
		default  :
					return 5;
				 /*	break;  */
	}

	
	return 0;

}

/* initialise la piece en pion */
void  set_pie_pio_blanc (void)
{
	set_pie_pio();
	pts_pie->pf_ini_hst_mvt		= ini_hst_mvt_pio_0;
	pts_pie->pf_jou 		= jou_pio_0;
	pts_pie->pf_ech_par		= ech_par_pio_0;
	pts_pie->pf_ctl_par		= ctl_par_pio_0;
	pts_pie->c_lib_pie		
	                                = *(_("LIB_PIE_P")+8) ;

}
void  set_pie_pio_noir (void)
{
	set_pie_pio();
	pts_pie->pf_ini_hst_mvt		= ini_hst_mvt_pio_1;
	pts_pie->pf_jou 		= jou_pio_1;
	pts_pie->pf_ech_par		= ech_par_pio_1;
	pts_pie->pf_ctl_par		= ctl_par_pio_1;
	pts_pie->c_lib_pie		
                                        = *(_("LIB_PIE_p")+8) ;
}
void  set_pie_pio (void)
{
	pts_pie->i_for  		= FOR_PIO;

	/* en cas de gros avantage la perte successive d'un pion dans chaque camp  <=> -1/2 pion */
	/*pts_pie->i_big_inc_ene 	= FOR_PIO + FOR_PIO/2;*/
	/*pts_pie->i_big_inc_pro 	= FOR_PIO - FOR_PIO/2;*/
	pts_pie->i_big_inc_ene 		= FOR_PIO + 1;
	pts_pie->i_big_inc_pro 		= FOR_PIO - 1;
	/* dans les autres cas la perte successive d'un pion dans chaque camp  <=> - cav  */
	/*pts_pie->i_lit_inc_ene 	= FOR_PIO + FOR_CAV;*/
	/*pts_pie->i_lit_inc_pro 	= FOR_PIO - FOR_CAV;*/

	pts_pie->i_lit_inc_ene 		= FOR_PIO + 1;
	pts_pie->i_lit_inc_pro 		= FOR_PIO - 1;

	pts_pie->defv_mvt_uni_dir       = Y;
	pts_pie->c_typ_pie	        = 'P';
	pts_pie->defv_typ_mvt_tou       = N;
	pts_pie->defv_typ_mvt_fou       = N;
	pts_pie->ptptdef_not_pos_pie    =tptdef_not_pos_pawn ; 
}

/* initialise la piece en cavalier */
void  set_pie_cav_blanc (void)
{
	set_pie_cav();
	pts_pie->c_lib_pie      
                                        = *(_("LIB_PIE_N")+8) ;

}
void  set_pie_cav_noir (void)
{
	set_pie_cav();
	pts_pie->c_lib_pie      
                                        = *(_("LIB_PIE_n")+8) ;
}
void  set_pie_cav (void)
{
	pts_pie->i_for		= FOR_CAV;
	/* en cas de gros avantage la perte successive d'un cavalier dans chaque camp  <=> -1 pion */
	/*pts_pie->i_big_inc_ene 	= FOR_CAV + FOR_PIO;*/
	/*pts_pie->i_big_inc_pro 	= FOR_CAV - FOR_PIO;*/

	pts_pie->i_big_inc_ene 		= FOR_CAV + 1;
	pts_pie->i_big_inc_pro 		= FOR_CAV - 1;
	/* dans les autres cas la perte successive d'un cavalier dans chaque camp  <=> -1 fou  */
	/*pts_pie->i_lit_inc_ene 	= FOR_CAV + FOR_CAV;*/
	/*pts_pie->i_lit_inc_pro 	= FOR_CAV - FOR_CAV;*/

	pts_pie->i_lit_inc_ene 		= FOR_CAV + 1;
	pts_pie->i_lit_inc_pro 		= FOR_CAV - 1;

	pts_pie->pf_ini_hst_mvt         = ini_hst_mvt_cav;
	pts_pie->pf_jou                 = jou_ctfr;
	pts_pie->pf_ech_par             = ech_par_cav;
	pts_pie->pf_ctl_par             = ctl_par_cav;
	pts_pie->defv_mvt_uni_dir       = Y;
	pts_pie->c_typ_pie              = 'C';
	pts_pie->defv_typ_mvt_tou       = N;
	pts_pie->defv_typ_mvt_fou       = N;
	pts_pie->ptptdef_not_pos_pie    =tptdef_not_pos_knight ; 

}

/* initialise la piece en tour */
void  set_pie_tou_blanc (void)
{
	set_pie_tou();
	pts_pie->c_lib_pie	
                                        = *(_("LIB_PIE_R")+8) ;
}
void  set_pie_tou_noir (void)
{
	set_pie_tou();
	pts_pie->c_lib_pie	
	                                = *(_("LIB_PIE_r")+8) ;
}

void  set_pie_tou (void)
{
	pts_pie->i_for  		= FOR_TOU;
	/* en cas de gros avantage la perte successive d'un cavalier dans chaque camp  <=> -1 fou */
	/*pts_pie->i_big_inc_ene 	= FOR_TOU + FOR_FOU;*/
	/*pts_pie->i_big_inc_pro 	= FOR_TOU - FOR_FOU;*/

	pts_pie->i_big_inc_ene 		= FOR_TOU + 1;
	pts_pie->i_big_inc_pro 		= FOR_TOU - 1;
	/* dans les autres cas la perte successive d'un cavalier dans chaque camp  <=> -1 reine  */
	/*pts_pie->i_lit_inc_ene 	= FOR_TOU + FOR_REI;*/
	/*pts_pie->i_lit_inc_pro 	= FOR_TOU - FOR_REI;*/

	pts_pie->i_lit_inc_ene 		= FOR_TOU + 1;
	pts_pie->i_lit_inc_pro 		= FOR_TOU - 1;

	pts_pie->pf_ini_hst_mvt  	= ini_hst_mvt_tou;
	pts_pie->pf_jou 		= jou_ctfr;
	pts_pie->pf_ech_par		= ech_par_tou;
	pts_pie->pf_ctl_par		= ctl_par_tou;
	pts_pie->defv_mvt_uni_dir       = N;
	pts_pie->c_typ_pie		= 'T';
	pts_pie->defv_typ_mvt_tou       = Y;
	pts_pie->defv_typ_mvt_fou       = N;
	pts_pie->ptptdef_not_pos_pie     =tptdef_not_pos_rook ; 

}

/* initialise la piece en fou */
void  set_pie_fou_blanc (void)
{
	set_pie_fou();
	pts_pie->c_lib_pie	
                                        = *(_("LIB_PIE_B")+8) ;
}
void  set_pie_fou_noir (void)
{
	set_pie_fou();
	pts_pie->c_lib_pie	
	                                = *(_("LIB_PIE_b")+8) ;
}

void  set_pie_fou (void)
{
	pts_pie->i_for  		= FOR_FOU;
	/* en cas de gros avantage la perte successive d'un cavalier dans chaque camp  <=> -1 cav */
	/*pts_pie->i_big_inc_ene 	= FOR_FOU + FOR_CAV;*/
	/*pts_pie->i_big_inc_pro 	= FOR_FOU - FOR_CAV;*/

	pts_pie->i_big_inc_ene 		= FOR_FOU + 1;
	pts_pie->i_big_inc_pro 		= FOR_FOU - 1;
	/* dans les autres cas la perte successive d'un cavalier dans chaque camp  <=> -1 reine  */
	/*pts_pie->i_lit_inc_ene 	= FOR_FOU + FOR_TOU;*/
	/*pts_pie->i_lit_inc_pro 	= FOR_FOU - FOR_TOU;*/

	pts_pie->i_lit_inc_ene 		= FOR_FOU + 1;
	pts_pie->i_lit_inc_pro 		= FOR_FOU - 1;

	pts_pie->pf_ini_hst_mvt         = ini_hst_mvt_fou;
	pts_pie->pf_jou 		= jou_ctfr;
	pts_pie->pf_ech_par		= ech_par_fou;
	pts_pie->pf_ctl_par		= ctl_par_fou;
	pts_pie->defv_mvt_uni_dir       = N;
	pts_pie->c_typ_pie		= 'F';
	pts_pie->defv_typ_mvt_tou       = N;
	pts_pie->defv_typ_mvt_fou       = Y;
	pts_pie->ptptdef_not_pos_pie    =tptdef_not_pos_bishop ; 

}

/* initialise la piece en reine */
void  set_pie_rei_blanc (void)
{
	set_pie_rei();
	pts_pie->c_lib_pie      
                                        = *(_("LIB_PIE_Q")+8) ;
}
void  set_pie_rei_noir (void)
{
	set_pie_rei();
	pts_pie->c_lib_pie      
                                        = *(_("LIB_PIE_q")+8) ;
}
void  set_pie_rei (void)
{
	pts_pie->i_for	  	        = FOR_REI;
	/* en cas de gros avantage la perte successive d'un cavalier dans chaque camp  <=> -1 tou */
	/*pts_pie->i_big_inc_ene 	= FOR_REI + FOR_TOU;*/
	/*pts_pie->i_big_inc_pro 	= FOR_REI - FOR_TOU;*/

	pts_pie->i_big_inc_ene 		= FOR_REI + 1;
	pts_pie->i_big_inc_pro 		= FOR_REI - 1;
	/* dans les autres cas la perte successive d'un cavalier dans chaque camp  <=> -1 mat  */
	/*pts_pie->i_lit_inc_ene 	= FOR_REI + NOT_MAT;*/
	/*pts_pie->i_lit_inc_pro 	= FOR_REI - NOT_MAT;*/

	pts_pie->i_lit_inc_ene 		= FOR_REI + 1;
	pts_pie->i_lit_inc_pro 		= FOR_REI - 1;

	pts_pie->pf_ini_hst_mvt         = ini_hst_mvt_rei;
	pts_pie->pf_jou                 = jou_ctfr;
	pts_pie->pf_ech_par             = ech_par_rei;
	pts_pie->pf_ctl_par             = ctl_par_rei;
	pts_pie->defv_mvt_uni_dir       = N;
	pts_pie->c_typ_pie              = 'D';
	pts_pie->defv_typ_mvt_tou       = Y;
	pts_pie->defv_typ_mvt_fou       = Y;
	pts_pie->ptptdef_not_pos_pie    =tptdef_not_pos_queen ; 

}

/* initialise la piece en roi */
void  set_pie_roi_blanc (void)
{
	set_pie_roi();
	pts_pie->c_lib_pie	
                                 = *(_("LIB_PIE_K")+8) ;
	pts_pie_pos_Roi[BLANC]= &pts_pie->i_pos_n; 
}
void  set_pie_roi_noir (void)
{
	set_pie_roi();
	pts_pie->c_lib_pie	
                                 = *(_("LIB_PIE_k")+8) ;
	pts_pie_pos_Roi[NOIR]= &pts_pie->i_pos_n; 
}

void  set_pie_roi (void)
{
	pts_pie->i_for  		= FOR_ROI;
	/* pas d'utilisation dans ce cas */
	pts_pie->i_big_inc_ene 		= 0;
	pts_pie->i_big_inc_pro 		= 0;
	/* pas d'utilisation dans ce cas */
	pts_pie->i_lit_inc_ene 		= 0;
	pts_pie->i_lit_inc_pro 		= 0;

	pts_pie->pf_ini_hst_mvt 	= ini_hst_mvt_roi;
	pts_pie->pf_jou 		= jou_roi;
	pts_pie->pf_ech_par		= ech_par_roi;
	pts_pie->pf_ctl_par		= ctl_par_roi;
	pts_pie->defv_mvt_uni_dir       = Y;
	pts_pie->c_typ_pie		= 'R';
	pts_pie->defv_typ_mvt_tou       = N;
	pts_pie->defv_typ_mvt_fou       = N;
	pts_pie->ptptdef_not_pos_pie    =tptdef_not_pos_king ; 

}

